#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <math.h>
#include <deque>
using namespace std;

#define pb push_back

#ifndef WIN32
#include <sys/resource.h>
#include <sys/times.h>
	float  userTime, sysTime;
	struct rusage myTime1, myTime2, myTime3;
	
	int userMem = 0;
#endif

int mNumber = 0;
int maxB = 0, maxD = 0;


void printTime(struct rusage myTime1)
{
//	printf("---\n");
	#ifndef WIN32
		getrusage(RUSAGE_SELF,&myTime2);
		userTime =
			((float) (myTime2.ru_utime.tv_sec  - myTime1.ru_utime.tv_sec)) +
			((float) (myTime2.ru_utime.tv_usec - myTime1.ru_utime.tv_usec)) * 1e-6;
		printf("%lf\n", userTime);
//		printf("user time: %lf s\n", userTime);
	#else
		cout<<"time: "<<(clock()-time1)/1000.0<<" s"<<endl;
	#endif
}


double abs(double x) {return x>0?(x):(-x);}

double r,d;
int n;
bool f1, f2 = 0, f3 = 0, f4 = 0, f5 = 0, f6 = 0, f7 = 0, f8 = 0;
bool fDfs = 0, fBfs = 0, fFindLayer = 0, fDelLayer = 0, fFindTree = 0, fDelTree = 0, fBuildTree;
bool fCross = 0;

const double EPS=1e-6;
struct point
{
	double x, y;
	bool operator == (const point & tmp) const
	{
		return abs(tmp.x - x) < EPS && abs(tmp.y - y) < EPS;
	}
	bool operator < (const point & tmp) const
	{
		return x < tmp.x - EPS || abs(tmp.x - x) < EPS && y < tmp.y - EPS;
	}
	point(double xx, double yy) {x=xx; y=yy;}
	point(){}

};

vector<vector<double> > disAB;

vector<point> a,b[4];
int dir;


double dis(const point & tmp, const point & tmp1)
{
	return sqrt( (tmp.x-tmp1.x)*(tmp.x-tmp1.x) + (tmp.y-tmp1.y)*(tmp.y-tmp1.y));
}

double crossXL(int p, int x, int y)
{
	if ( dis(point(x*d, y*d), b[dir][p])<=r ) return x*d;
	else 
	{
		double tmp = sqrt(r*r-(y*d-b[dir][p].y)*(y*d-b[dir][p].y));
		if (x*d <= b[dir][p].x - tmp && b[dir][p].x - tmp <= x*d+d) return  b[dir][p].x - tmp;
		else return b[dir][p].x + tmp;
	}
}

double crossXR(int p, int x, int y)
{
	if ( dis(point((x+1)*d, y*d), b[dir][p])<=r ) return (x+1)*d;
	else 
	{
		double tmp = sqrt(r*r-(y*d-b[dir][p].y)*(y*d-b[dir][p].y));
		if (x*d <= b[dir][p].x + tmp && b[dir][p].x + tmp <= x*d+d) return  b[dir][p].x + tmp;
		else return b[dir][p].x - tmp;
	}
}
double crossY(int p, int q)
{
	if (b[dir][p].x > b[dir][q].x) swap(p,q);
	

	double pq = dis(b[dir][p], b[dir][q]);
	
	double a1 = atan2(sqrt(4*r*r - pq*pq), pq);
	double a2 = atan2(abs(b[dir][p].y - b[dir][q].y), abs(b[dir][p].x - b[dir][q].x) );
	
	if (b[dir][p].y > b[dir][q].y) 
	{
		return b[dir][p].y + r * sin(a1-a2);
	}	
	else 
	{
		return b[dir][p].y + r * sin(a1+a2);
	}
}


double crossX(int p, int q)
{
	if (b[dir][p].x > b[dir][q].x) swap(p,q);
		
	double pq = dis(b[dir][p], b[dir][q]);
	
	double a1 = atan2(sqrt(4*r*r - pq*pq), pq);
	double a2 = atan2(abs(b[dir][p].y - b[dir][q].y), abs(b[dir][p].x - b[dir][q].x) );
	
	if (b[dir][p].y > b[dir][q].y) 
	{
		return b[dir][p].x + r * cos(a1-a2);
	}	
	else 
	{
		return b[dir][p].x + r * cos(a1+a2);
	}
}

double getY(int p, double x)
{
	return sqrt(r*r-(x-b[dir][p].x)*(x-b[dir][p].x)) + b[dir][p].y;
}


#define pos(x,y) ((x+y)|(x!=y))
#define mid(x,y) ((x+y)>>1)


bool cmp(int i, int j)
{
	return b[dir][i].x < b[dir][j].x - EPS || abs(b[dir][i].x - b[dir][j].x) < EPS && b[dir][i].y < b[dir][j].y - EPS
		|| abs(b[dir][i].x - b[dir][j].x) < EPS && abs(b[dir][i].y - b[dir][j].y) < EPS && i<j;
}

struct segTree
{
	int n;
	bool yLabel;

	int gridX, gridY;
	bool rebuild;
	int delP;
	vector<int> lCross, rCross;
	vector<deque<int> > tList;
	vector<bool> fLeft, fRight;

	vector<int> tmp;
	vector<int> pList;
	segTree(int x, int y) {gridX = x; gridY = y; pList.clear(); tmp.clear();}
	segTree(){tmp.clear();pList.clear();}
		
	void build_dfs(int x, int y)
	{
		int id = pos(x,y);
		if (x == y)
		{
			tList[id].resize(1);
			tList[id][0] = pList[x];
			return;
		}
		
		if (rebuild && 1)
		{
			if (cmp( delP, tmp[mid(x,y)] ) || delP== tmp[mid(x,y)])	build_dfs(x, mid(x,y));
			else build_dfs(mid(x,y)+1, y);
		}
		else
		{
			build_dfs(x, mid(x,y));
			build_dfs(mid(x,y)+1, y);
		}
		
		int lid = pos(x, mid(x,y)), rid = pos(mid(x,y)+1, y);
		
		if (tList[lid][0] == -1 && 	tList[rid][0] == -1)
		{
			tList[id].resize(1);
			tList[id][0] = -1;
			return;
		}
		
		if (tList[rid][0] == -1)
		{
			tList[id] = tList[lid];
			return;
		}
		else if (tList[lid][0] == -1)
		{
			tList[id] = tList[rid];
			return;
		}
		
		fCross = 0;



		fLeft.resize(0);
		fRight.resize(0);
		fLeft.resize(tList[lid].size(), false);
		fRight.resize(tList[rid].size(), false);
		fLeft[0] = true;
		double nextI, nextJ, lastI = b[dir][tList[lid][0]].x-r, lastJ = b[dir][tList[rid][0]].x-r;
		for (int i = 0, j =0, ii = fLeft.size(), jj = fRight.size(); i < ii && j < jj;)
		{
			if (lastI < b[dir][tList[lid][i]].x - r) lastI = b[dir][tList[lid][i]].x - r;
			if (lastJ < b[dir][tList[rid][j]].x - r) lastJ = b[dir][tList[rid][j]].x - r;
			
			if (i < ii-1 && b[dir][tList[lid][i]].x + r <= b[dir][tList[lid][i+1]].x - r  )
				nextI = b[dir][tList[lid][i]].x + r;
			else if (i < ii-1 && dis(b[dir][tList[lid][i]], b[dir][tList[lid][i+1]]) >= 2*r )
				nextI = b[dir][tList[lid][i]].y > b[dir][tList[lid][i+1]].y ? b[dir][tList[lid][i]].x + r : b[dir][tList[lid][i+1]].x - r;
			else if (i == ii-1 || crossY(tList[lid][i], tList[lid][i+1]) < b[dir][tList[lid][i]].y) 
				nextI = b[dir][tList[lid][i]].x + r;
			else nextI = crossX(tList[lid][i], tList[lid][i+1]);

			if (j < jj-1 && b[dir][tList[rid][j]].x + r <= b[dir][tList[rid][j+1]].x - r  )
				nextJ = b[dir][tList[rid][j]].x + r;
			else if (j < jj-1 && dis(b[dir][tList[rid][j]], b[dir][tList[rid][j+1]]) >= 2*r )
				nextJ = b[dir][tList[rid][j]].y > b[dir][tList[rid][j+1]].y ? b[dir][tList[rid][j]].x + r : b[dir][tList[rid][j+1]].x - r;
			else if (j == jj-1 || crossY(tList[rid][j], tList[rid][j+1]) < b[dir][tList[rid][j]].y) 
				nextJ = b[dir][tList[rid][j]].x + r;
			else nextJ = crossX(tList[rid][j], tList[rid][j+1]);


			if (lastI < b[dir][tList[rid][0]].x-r) fLeft[i] = 1;
			if (nextJ > b[dir][tList[lid][ii-1]].x+r) fRight[j] = 1;

			if (nextI <= lastJ)
			{
				fLeft[i++] = true;
				lastI = nextI;
			}
			else if (nextJ <= lastI)
			{
				fRight[j++] = true;
				lastJ = nextJ;
			}
			else if (nextI <= nextJ)
			{
				if ( getY(tList[lid][i], max(lastI, lastJ)) >= getY(tList[rid][j], max(lastI, lastJ)) )
					fLeft[i] = true;
				else fRight[j] = true;

				if ( getY(tList[lid][i], nextI) >= getY(tList[rid][j], nextI) )
					fLeft[i] = true;
				else fRight[j] = true;

				i++;
				lastI = nextI;
			}
			else if (nextJ <= nextI)
			{
				if ( getY(tList[lid][i], max(lastI, lastJ)) >= getY(tList[rid][j], max(lastI, lastJ)) )
					fLeft[i] = true;
				else fRight[j] = true;

				if ( getY(tList[lid][i], nextJ) >= getY(tList[rid][j], nextJ) )
					fLeft[i] = true;
				else fRight[j] = true;


				j++;
				lastJ = nextJ;
			}

			if (i == ii) while (j < jj) fRight[j++] = 1;
		}
		tList[id].resize(0);
		for (int i = 0, ii = fLeft.size(); i < ii; i++ )
			if (fLeft[i]) tList[id].pb(tList[lid][i]);
		for (int i = 0, ii = fRight.size(); i < ii; i++ )
			if (fRight[i]) tList[id].pb(tList[rid][i]);

	}
	
	
	void build()
	{
		n = pList.size();
		sort(pList.begin(), pList.end(), cmp);
		tmp = pList;

		lCross.resize(2*n-1);
		rCross.resize(2*n-1);
		tList.resize(2*n-1);
		rebuild = 0;
		build_dfs(0, n-1);
	}
	
	int find_dfs(int x, int y, int p)
	{
		int id = pos(x,y);
		if (x == y)
		{
			if (pList[x] == -1 || dis(a[p], b[dir][pList[x]]) > r ) return -1;
			else return pList[x];
		}
		int lid = pos(x, mid(x,y)), rid = pos(mid(x,y)+1, y);

		
		if (tList[id][0] == -1) return -1;
		if (tList[rid][0] == -1) return find_dfs(x, mid(x,y), p);
		if (tList[lid][0] == -1) return find_dfs(mid(x,y)+1, y, p);

		if ( a[p].x <= crossX(lCross[id], rCross[id]) ) return find_dfs(x, mid(x,y), p);
		else return find_dfs(mid(x,y)+1, y, p);
	}
	
	
	
	int find(int p)
	{
		
		if (pList.size() < 30)
		{
			for (int i = 0, ii = pList.size(); i < ii; i++)
				if (pList[i] != -1 && dis(b[dir][pList[i]], a[p])<=r ) 
					return pList[i];
			return -1;
		}

		int ans = find_dfs(0, n-1, p);
		f7 = 0;	
		return ans;
		
	}
	
	
	void del_dfs(int x, int y, int p)
	{
		int id = pos(x,y);
		if (x == y) 
		{
			tList[id][0] = pList[x] = -1;
			return;			
		}
		
		int lid = pos(x, mid(x,y)), rid = pos(mid(x,y)+1, y);
				
		if (tList[id][0] == -1) return;
		if (tList[rid][0] == -1) {del_dfs(x, mid(x,y), p); return;}
		if (tList[lid][0] == -1) {del_dfs(mid(x,y)+1, y, p); return;}
		
		if ( !rebuild ) 
		{
			rebuild = 1;
			if ( cmp( p, tmp[mid(x,y)] ) || p== tmp[mid(x,y)] ) del_dfs(x, mid(x,y), p);
			else del_dfs(mid(x,y)+1, y, p);
			delP = p;
			build_dfs(x,y);
		}
		else
		{
			if ( cmp( p, tmp[mid(x,y)] ) || p== tmp[mid(x,y)] ) del_dfs(x, mid(x,y), p);
			else del_dfs(mid(x,y)+1, y, p);
		}
		
	}
	
	void del(int p)
	{

		rebuild = 0;
		del_dfs(0, n-1, p);
		
	}
	
};



struct layer
{
	vector<int> pList;
	map< pair<int,int>, segTree> tList[4];
	map< pair<int,int>, set<int> > iList;
	map<point, int> oList;

	void build()
	{
		oList.clear();
		iList.clear();
		for (int i = 0; i < 4; i++)
			tList[i].clear();
		
		for (int id = 0, ii = pList.size(), x, y; id < ii; id++)
		{

			double px = b[0][pList[id]].x, py = b[0][pList[id]].y;
			x = int(floor(px/d)); y = int(floor(py/d));

				oList[b[0][pList[id]] ] = pList[id];

			for (int i = x-3; i <= x+3; i++)
				for (int j = y-3; j <= y+3; j++)
				{
					if ( dis(point(i*d, j*d), point(px,py) ) < r
						&& dis(point((i+1)*d, j*d),  point(px,py) ) < r
						&& dis(point(i*d, (j+1)*d),  point(px,py) ) < r
						&& dis(point((i+1)*d, (j+1)*d),  point(px,py) ) < r )
					{

						if ( iList.find(make_pair(i,j))==iList.end() )
							iList[make_pair(i,j)] = set<int>();
						iList[make_pair(i,j)].insert( pList[id] );
						continue;
					}
					
					for (int k = 0; k < 4; k++)
					{
						if (0 <= j*d-py)
						if (i*d <= px && px <= (i+1)*d && j*d-py < r
							|| px < i*d && dis(point(i*d, j*d), point(px,py)) <r
							|| (i+1)*d < px && dis(point(i*d+d, j*d), point(px,py)) < r)
						{
							if (tList[k].find( make_pair(i,j) ) == tList[k].end())
								tList[k][make_pair(i,j)] = segTree(i,j);
							tList[k][make_pair(i,j)].pList.pb( pList[id] );
						}

						swap(i, j); i = -i;		
						swap(px, py); px = -px;					
					}
					
				}

		}
		
		for (dir = 0; dir < 4; dir++)
			for (map< pair<int,int>, segTree>::iterator it = tList[dir].begin(); it != tList[dir].end(); it++ )
			{
				it->second.build();
			}

	}

	int find(int p)
	{
		
		int x = int(floor(a[p].x/d)), y = int(floor(a[p].y/d));
		if ( oList.find( point(a[p].x + r, a[p].y) ) != oList.end())
			return oList[point(a[p].x + r, a[p].y)];
		if ( oList.find( point(a[p].x - r, a[p].y) ) != oList.end())
			return oList[point(a[p].x - r, a[p].y)];
		if ( oList.find( point(a[p].x, a[p].y + r) ) != oList.end())
			return oList[point(a[p].x, a[p].y + r)];
		if ( oList.find( point(a[p].x, a[p].y - r) ) != oList.end())
			return oList[point(a[p].x, a[p].y - r)];
		
		

		if (iList.find(make_pair(x,y))!=iList.end() && !iList[make_pair(x,y)].empty())
		{
			return *iList[make_pair(x,y)].begin();
		}

		int ans = -1;

		for (dir = 0; dir < 4; dir++)
		{
			x = int(floor(a[p].x/d)); y = int(floor(a[p].y/d));
			
			f1 = 1;
			if (ans == -1 && tList[dir].find(make_pair(x,y)) != tList[dir].end() )
			{
				if (fFindLayer && dir == 0 && x == 5 && y == 29) fFindTree = 1;
				ans = tList[dir][make_pair(x,y)].find(p);
				if (fFindLayer && dir == 0 && x == 5 && y == 29) fFindTree = 0;
			}	 
			f1 = 0;
			swap(a[p].x, a[p].y); a[p].x = -a[p].x;			
		}

		return ans;
	}

	void del(int p)
	{
		if (oList.find(b[0][p]) != oList.end())
			oList.erase(b[0][p]);
		
		double px = b[0][p].x, py = b[0][p].y;
		int x = int(floor(px/d)), y = int(floor(py/d));

		for (int i = x-3; i <= x+3; i++)
			for (int j = y-3; j <= y+3; j++)
			{

			
				if ( dis(point(i*d, j*d), b[0][p] ) < r
					&& dis(point((i+1)*d, j*d), b[0][p] ) < r
					&& dis(point(i*d, (j+1)*d), b[0][p] ) < r
					&& dis(point((i+1)*d, (j+1)*d), b[0][p] ) < r )
				{
					iList[make_pair(i,j)].erase( p );
					continue;
				}

					
				for (dir = 0; dir < 4; dir++)
				{
					if (0 <= j*d-b[dir][p].y)
					if (i*d <= b[dir][p].x && b[dir][p].x <= (i+1)*d && j*d-b[dir][p].y < r
						|| b[dir][p].x < i*d && dis(point(i*d, j*d), b[dir][p]) <r
						|| (i+1)*d < b[dir][p].x && dis(point(i*d+d, j*d), b[dir][p]) < r)
					{
						tList[dir][make_pair(i,j)].del(p);
					}
					swap(i, j); i = -i;		
				}
					
			}
		
		
	}
		
	layer()
	{
		pList.clear(); oList.clear(); iList.clear(); 
		for (int i = 0; i < 4; i++) tList[i].clear();
	}

};

struct graph
{
	vector<layer> ly;
	vector<int> lastMb, L1, mb;
	vector<pair<int,int> > q;
	bool *ma;
	bool noB;

	void init()
	{
		mb.resize(0);
		mb.resize(n, -1);
		ma = new bool[n];
	}
	
		
	void backLast()
	{
		mb = lastMb;
	}

	void storeLast()
	{
		lastMb = mb;
	}

	void bfs()
	{
		ly.resize(0);
		ly.resize(1);
		for (int i = 0; i < n; i++)
			ly[0].pList.pb(i);
				
		ly[0].build();
		

		
		for (int i = 0; i < n; i++) ma[i] = 1;
		for (int i = 0; i < n; i++)
			if (mb[i] != -1) ma[mb[i]] = 0;

		q.resize(0);

		L1.resize(0);
		for (int i = 0; i < n; i++)
		{

			if (ma[i])
			{
				L1.pb(i);
				q.pb(make_pair(i,1));

			}
		}
		
		noB = 1;
		
		vector<pair<int,int> >::iterator qh = q.begin();

		double tmpTime = 0;
		int noBsecond = -1;
		while (qh != q.end() && noBsecond != qh->second)
		{
			int cnt = 0;
			for (int i; ( i = ly[0].find(qh->first) )!=-1; )
			{
				f3 = 0;
				maxB = maxB>qh->second?maxB:qh->second;

				ly[0].del(i);

				if (ly.size() <= qh->second) ly.resize(ly.size()+1);

				if (mb[i] == -1)
				{
					if (noB)	ly[qh->second].pList.clear();
					ly[qh->second].pList.pb(i);
					noBsecond = qh->second+1;
					noB = 0;

				}
				else if (noB)
				{
					ly[qh->second].pList.pb(i);
					q.pb( make_pair(mb[i], qh->second+1) );
				}

				if (qh->first == 751 && i == 1611 ) fFindLayer = 1;
			}
			if (qh->first == 751 ) fFindLayer = 0;	
			f2 = 0;
			qh++;
		}

		for (int i = 1; i < ly.size(); i++)
			ly[i].build();

		
	}


	bool dfs(int p, int x)
	{
		maxD = maxD>x?maxD:x;
		if (p == -1) 
		{
			mNumber++;
			return true;
		}


		
		for (int i; (i = ly[x].find(p))!= -1;)
		{
			ly[x].del(i);

			if (dfs(mb[i], x+1))
			{
				mb[i] = p;
				return true;
			}
		}
		
		return false;
	}


};




graph g;
vector<int> ansM;
double ansR;

vector<double> disK;




void run()
{
	disAB.resize(n);
	disK.resize(n*n);

	for (int i = 0; i < n; i++)
	{
		disAB[i].resize(n);
		for (int j = 0; j < n; j++)
		{
			disAB[i][j] = disK[i*n+j] = dis(a[i], b[0][j]);

		}
	}


	sort(disK.begin(), disK.end());

//	getrusage(RUSAGE_SELF,&myTime1);

	g.init();
	for (int lb = 0, ub = disK.size()-1; lb <= ub; )
	{
		for (int sp = int(ceil((ub-lb+1)/pow(n, 1/7.0))), i = lb ; i <= ub; i += sp )
		{
			r = disK[i];
			d = r/2;
			bool tmpF = 0;
			while (1)
			{
				
				maxB = 0;
				g.bfs();
				
				if (g.noB || n-g.L1.size() < n-sqrt(n) && (g.ly.size()-1)*2 > sqrt(n) ) break;
				
				maxD = 0;
				for (int i = 0, ii = g.L1.size(); i < ii; i++)
				{
					bool tmpB = g.dfs(g.L1[i], 1);
				}

			}
			
			if (g.L1.size() == 0)
			{
				ansR = i;
				ansM = g.mb;
				ub = i-1;
				g.backLast();
			}
			else
			{
				lb = i+1; 
				g.storeLast();
			}
			
		}

	}
	printf("Minimum Radius is %lf\n", ansR);
	printTime(myTime1);
}


void init(char **argv)
{
	FILE *fa, *fb;
	fa = fopen(argv[2], "r");	
	fb = fopen(argv[1], "r");

	point tmp; 
	int x;
	char str[500];

	char cc;
	while (fscanf(fa, "%d%c%d", &x,&cc,&x)!=EOF)
	{
		fscanf(fa, "%lf%lf", &tmp.x, &tmp.y);
		fgets(str, 500, fa);		
		a.pb(tmp);
	}
	n = a.size();

	for (int i = 0; i < n; i++)
	{
		fscanf(fb, "%d%c%d", &x, &cc, &x);
		fscanf(fb, "%lf%lf", &tmp.x, &tmp.y);
		fgets(str, 500, fb);
		for (int i = 0; i < 4; i++)
		{
			b[i].pb(tmp);
			swap(tmp.x, tmp.y); tmp.x = -tmp.x;
		}

	}
	dir = 0;
}



int main(int argc, char **argv)
{
	
	init(argv);
	run();
	
	return 0;

}






