/*
  This code was written by Raymond Chi-Wing Wong.
  Please read the following.

    Raymond Chi-Wing Wong, Yufei Tao, Ada Wai-Chee Fu and Xiaokui Xiao. 
    "On Efficient Spatial Matching", 
    the 33rd International Conference on Very Large Data Bases (VLDB'07), 
    Vienna, Austria on 23-28 Sept, 2007 

*/

#ifndef RSA_H
#define RSA_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "point.h"
#include "rtree.h"
#include "config.h"
#include "assignment.h"
#include "statistics.h"

void findOMatch(int oid, int pid, NN_type *oNode, twoData *aTwoData, node_type *rootO, node_type *rootP, configure *aConfigure, assignment *aAssignment, int chainLen);
void findPMatch(int pid, int oid, NN_type *pNode, twoData *aTwoData, node_type *rootO, node_type *rootP, configure *aConfigure, assignment *aAssignment, int chainLen);

assignment *findStableAssignment(twoData *aTwoData, node_type *rootO, node_type *rootP, configure *aConfigure);

assignment *spm_weightedChain(twoData *aTwoData, node_type *rootO, node_type *rootP, configure *aConfigure);

#endif
